Package org.optaplanner.core.config.heuristic.selector.move.factory

## Class MoveListFactoryConfig

- java.lang.Object
- - org.optaplanner.core.config.AbstractConfig<C>
  - - org.optaplanner.core.config.heuristic.selector.SelectorConfig<C>
    - - org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig<MoveListFactoryConfig>
      - - org.optaplanner.core.config.heuristic.selector.move.factory.MoveListFactoryConfig

-     public class MoveListFactoryConfig
      extends MoveSelectorConfig<MoveListFactoryConfig>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Class<? extends MoveListFactory>` | `moveListFactoryClass` |
    `protected Map<String,​String>` | `moveListFactoryCustomProperties` |

    - ### Fields inherited from class org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig

      `cacheType, filterClassList, probabilityWeightFactoryClass, selectedCountLimit, selectionOrder, sorterClass, sorterComparatorClass, sorterOrder, sorterWeightFactoryClass`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MoveListFactoryConfig()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `MoveSelector` | `buildBaseMoveSelector​(HeuristicConfigPolicy configPolicy, SelectionCacheType minimumCacheType, boolean randomSelection)` |
    `MoveListFactoryConfig` | `copyConfig()` | Typically implemented by constructing a new instance and calling `AbstractConfig.inherit(AbstractConfig)` on it
    `Class<? extends MoveListFactory>` | `getMoveListFactoryClass()` |
    `Map<String,​String>` | `getMoveListFactoryCustomProperties()` |
    `MoveListFactoryConfig` | `inherit​(MoveListFactoryConfig inheritedConfig)` | Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).
    `protected boolean` | `isBaseInherentlyCached()` |
    `void` | `setMoveListFactoryClass​(Class<? extends MoveListFactory> moveListFactoryClass)` |
    `void` | `setMoveListFactoryCustomProperties​(Map<String,​String> moveListFactoryCustomProperties)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig

      `buildMoveSelector, buildUnfoldedMoveSelectorConfig, determineBaseRandomSelection, extractLeafMoveSelectorConfigsIntoList, getCacheType, getFilterClassList, getFixedProbabilityWeight, getProbabilityWeightFactoryClass, getSelectedCountLimit, getSelectionOrder, getSorterClass, getSorterComparatorClass, getSorterOrder, getSorterWeightFactoryClass, inheritFolded, setCacheType, setFilterClassList, setFixedProbabilityWeight, setProbabilityWeightFactoryClass, setSelectedCountLimit, setSelectionOrder, setSorterClass, setSorterComparatorClass, setSorterOrder, setSorterWeightFactoryClass, withCacheType, withFilterClassList, withFixedProbabilityWeight, withProbabilityWeightFactoryClass, withSelectedCountLimit, withSelectionOrder, withSorterClass, withSorterComparatorClass, withSorterOrder, withSorterWeightFactoryClass`

    - ### Methods inherited from class org.optaplanner.core.config.heuristic.selector.SelectorConfig

      `validateCacheTypeVersusSelectionOrder`

    - ### Methods inherited from class org.optaplanner.core.config.AbstractConfig

      `deduceEntityDescriptor, deduceVariableDescriptor, deduceVariableDescriptorList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### moveListFactoryClass

          protected Class<? extends MoveListFactory> moveListFactoryClass

    - #### moveListFactoryCustomProperties

          @XStreamConverter(KeyAsElementMapConverter.class)
          protected Map<String,​String> moveListFactoryCustomProperties

  - ### Constructor Detail

    - #### MoveListFactoryConfig

          public MoveListFactoryConfig()

  - ### Method Detail

    - #### getMoveListFactoryClass

          public Class<? extends MoveListFactory> getMoveListFactoryClass()

    - #### setMoveListFactoryClass

          public void setMoveListFactoryClass​(Class<? extends MoveListFactory> moveListFactoryClass)

    - #### getMoveListFactoryCustomProperties

          public Map<String,​String> getMoveListFactoryCustomProperties()

    - #### setMoveListFactoryCustomProperties

          public void setMoveListFactoryCustomProperties​(Map<String,​String> moveListFactoryCustomProperties)

    - #### isBaseInherentlyCached

          protected boolean isBaseInherentlyCached()

      Overrides:
        `isBaseInherentlyCached` in class `MoveSelectorConfig<MoveListFactoryConfig>`

    - #### buildBaseMoveSelector

          public MoveSelector buildBaseMoveSelector​(HeuristicConfigPolicy configPolicy,
                                                    SelectionCacheType minimumCacheType,
                                                    boolean randomSelection)

      Specified by:
        `buildBaseMoveSelector` in class `MoveSelectorConfig<MoveListFactoryConfig>`
      Parameters:
        `configPolicy` - never null
        `minimumCacheType` - never null, If caching is used (different from `SelectionCacheType.JUST_IN_TIME`), then it should be at least this `SelectionCacheType` because an ancestor already uses such caching and less would be pointless.
        `randomSelection` - true is equivalent to `SelectionOrder.RANDOM`, false is equivalent to `SelectionOrder.ORIGINAL`
      Returns:
        never null

    - #### inherit

          public MoveListFactoryConfig inherit​(MoveListFactoryConfig inheritedConfig)

      Description copied from class: `AbstractConfig`
      Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).

      After the inheritance, if a property on this `AbstractConfig` composition is replaced, it should not affect the inherited composition instance.

      Overrides:
        `inherit` in class `MoveSelectorConfig<MoveListFactoryConfig>`
      Parameters:
        `inheritedConfig` - never null
      Returns:
        this

    - #### copyConfig

          public MoveListFactoryConfig copyConfig()

      Description copied from class: `AbstractConfig`
      Typically implemented by constructing a new instance and calling `AbstractConfig.inherit(AbstractConfig)` on it
      Specified by:
        `copyConfig` in class `AbstractConfig<MoveListFactoryConfig>`
      Returns:
        new instance

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractConfig<MoveListFactoryConfig>`